<template>
  <div class="messaging-message-list-item-overview" @click="onClick">
    <div class="messaging-message-list-item-overview__avatar">
      <router-link :to="route">
        <UserAvatar :user="otherUser" :route="route" size="md" />
      </router-link>
    </div>
    <div class="messaging-message-list-item-overview__main">
      <h4>
        <router-link :to="route">{{ otherUsername }}</router-link>
      </h4>
      <div class="messaging-message-list-item-overview__body">
        <div class="messaging-message-list-item-overview__overview">
          <span v-html="overviewBody" />
        </div>
        <div class="messaging-message-list-item-overview__created">
          <span data-bs-toggle="tooltip" :title="sentTooltip">{{ sentText }}</span>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
const MAX_CHARS = 200 // This will be cropped further using CSS if need be.

import { computed } from 'vue'
import { useRouter } from 'vue-router'
import { useStore } from 'vuex'
import { StringHelper, useMarkdown } from '../../core'
import { UserAvatar } from '../../gallery'
import { useMessageListItem } from './message-list-item.js'

export default {
  name: 'MessagingMessageListItemOverview',
  components: {
    UserAvatar,
  },
  props: {
    message: { type: Object, required: true },
  },
  setup(props) {
    const baseProperties = useMessageListItem(props)

    const router = useRouter()
    const store = useStore()
    const markdown = useMarkdown()

    const route = computed(() => {
      return store.state.identity.session.username
        ? { name: 'messaging-messages-conversation', params: { username: store.state.identity.session.username } }
        : null
    })

    const formattedBody = computed(() => {
      return markdown.toHtml(props.message.body, true)
    })

    const overviewBody = computed(() => {
      return StringHelper.summary(formattedBody.value, MAX_CHARS)
    })

    const otherUser = computed(() => {
      return store.state.identity.session.userId === props.message.fromUserId
        ? props.message.toUser
        : props.message.fromUser
    })

    const otherUsername = computed(() => {
      return otherUser.value?.username || ''
    })

    const onclick = () => {
      router.push(route.value)
    }

    return {
      ...baseProperties,
      route,
      overviewBody,
      otherUser,
      otherUsername,
      onclick,
    }
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.messaging-message-list-item-overview {
  display: flex;
  margin: 0 (-(vars.$spacing));
  padding: vars.$spacing;
  color: vars.$subtextColor;
}

.dark .messaging-message-list-item-overview {
  color: vars.$darkSubtextColor;
}

.messaging-message-list-item-overview__avatar {
  flex: auto 0 0;
  margin-right: vars.$spacing;
}

.messaging-message-list-item-overview__main {
  flex: auto 1 1;
  min-width: 0; // Stops the text from overflowing
}

.messaging-message-list-item-overview__body {
  display: flex;
  width: 100%;
}

.messaging-message-list-item-overview__overview {
  flex: auto 1 1;
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}

.messaging-message-list-item-overview__message {
  flex: auto 1 1;
}

.messaging-message-list-item-overview__created {
  flex: auto 0 0;
  margin-left: vars.$spacing;
  white-space: nowrap;
}
</style>
